package com.bizerba.jpos.scalecsoem.UPOSLib;

public interface IUposScale {
	public long OptionalPreInit(String configfile, String errorText[]); // ID: 1
	public long Exit(); // ID: 2
	public long Init(String moduleFileName1, String moduleFileName2, int approvalJava, String version, String errorText[]); // ID: 3
	public long Open(String name, long insthdl[], String errorText[]); // ID: 4
	public long Close(long insthdl, String errorText[]); // ID: 5
	public long Claim(long insthdl, long timeout_in_ms, String[] errorText); // ID: 6
	public long ReleaseDevice(long insthdl, String[] errorText); // ID: 7
	public long GetClaimed(long insthdl, boolean claimed[], String errorText[]); // ID: 8
	public long GetDeviceEnabled(long insthdl, boolean[] enabled, String[] errorText); // ID: 9
	public long SetDeviceEnabled(long insthdl, boolean enabled, String[] errorText); // ID: 10
	public long GetState(long insthdl, long[] state, String[] errorText); // ID: 11
	public long DirectIO(long insthdl, long id, long[] data, Object[] datastring, String[] errorText); // ID: 12
	public long SetAsyncMode(long insthdl, boolean asyncMode, String[] errorText); // ID: 13
	public long GetAsyncMode(long insthdl, boolean[] asyncmode, String[] errorText); // ID: 14
	public long CapDisplay(long insthdl, boolean[] capdisplay, String[] errorText); // ID: 15
	public long CapDisplayText(long insthdl, boolean[] capdisplaytext, String[] errorText); // ID: 16
	public long CapPriceCalculating(long insthdl, boolean[] cappricecalculating, String[] errorText); // ID: 17
	public long CapTareWeight(long insthdl, boolean[] captareweight, String[] errorText); // ID: 18
	public long CapZeroScale(long insthdl, boolean[] capzeroweight, String[] errorText); // ID: 19
	public long GetMaxDisplayTextChars(long insthdl, long[] maxdisplaytextchars, String[] errorText); // ID: 20
	public long GetSalesPrice(long insthdl, long[] salesprice, String[] errorText); // ID: 21
	public long SetTareWeight(long insthdl, int tareWeight, String[] errorText); // ID: 22
	public long GetTareWeight(long insthdl, long[] tareweight, String[] errorText); // ID: 23
	public long SetUnitPrice(long insthdl, long unitPrice, String[] errorText); // ID: 24
	public long GetUnitPrice(long insthdl, long[] unitprice, String[] errorText); // ID: 25
	public long GetWeightUnit(long insthdl, long[] weightunit, String[] errorText); // ID: 26
	public long SetDisplayText(long insthdl, String text, String[] errorText); // ID: 27
	public long ReadWeight(long insthdl, long[] readweight, long timeout, String[] errorText); // ID: 28
	public long ZeroScale(long insthdl, String[] errorText); // ID: 29
	public long ScaleLiveWeight(long insthdl, long[] liveweight, String[] errorText); // ID: 30
	public long GetMaximumWeight(long insthdl, long[] maximumweight, String[] errorText); // ID: 31
	public long KillActualCommand(long insthdl, String[] errorText); // ID: 32
	public long GetDeviceServiceDescription(long insthdl, String[] deviceServiceDesctription, String[] errorText); // ID: 33
	public int GetDeviceServiceVersion(); // ID: 34
	public long CheckHealth(long insthdl, long level, String[] errorText); // ID: 35
	public long GetHealthText(long insthdl, String[] healthText, String[] errorText); // ID: 36
	public long ZeroValid(long insthdl, boolean[] zeroValid, String[] errorText); // ID: 37
	public long DoPriceCalculating(long insthdl, int[] weightData, int[] tare, long[] unitPrice,
			long[] unitPriceX, int[] weightUnitX, int[] weightNumeratorX, int[] weightDenominatorX, long[] price, int timeout, String[] errorText); // ID: 38
	public long freezeValue(long insthdl, int item, boolean freeze, String[] errorText); // ID: 39
	public long CapFreezeValue(long insthdl, boolean[] capFreezeValue, String[] errorText); // ID: 40
	public long CapReadLiveWeightWithTare(long insthdl, boolean[] capReadLiveWeightWithTare, String[] errorText); // ID: 41
	public long CapSetPriceCalculationMode(long insthdl, boolean[] capSetPriceCalculationMode, String[] errorText); // ID: 42
	public long CapSetUnitPriceWithWeightUnit(long insthdl, boolean[] capSetUnitPriceWithWeightUnit, String[] errorText); // ID: 43
	public long CapSpecialTare(long insthdl, boolean[] capSpecialTare, String[] errorText); // ID: 44
	public long CapTarePriority(long insthdl, boolean[] capTarePriority, String[] errorText); // ID: 45
	public long GetMinimumWeight(long insthdl, long[] minimumweight, String[] errorText); // ID: 46
	public long ReadLiveWeightWithTare(long insthdl, int[] weightData, int[] tare, int timeout, String[] errorText); // ID: 47
	public long SetPriceCalculationMode(long insthdl, int mode, String[] errorText); // ID: 48
	public long SetSpecialTare(long insthdl, int mode, int data, String[] errorText); // ID: 49
	public long SetTarePrioity(long insthdl, int priority, String[] errorText); // ID: 50
	public long SetUnitPriceWithWeightUnit(long insthdl, long unitPrice, int weightUnit,
			int weightNumerator, int weightDenominator, String[] errorText); // ID: 51
}